c hcscom13_5
c include file for hcs
      parameter(maxage=15,maxyr=30,maxyrp=maxyr+maxage,niter=1000,
     &mbasis=5,nopt=26)
c maxage is for dimensioning of arrays. The active largest age is iaold
c maxyr determines the year range of the analysis. Should not be more than 98 to avoid trouble with formats.
c niter is the number of iterations.
c mbasis has a double role. It shall give enough space for data in bases that go into the future,
c and it dimensions things related to the number of bases. It should be large enough for both purposes
c Note: Change in maxage, maxyr or niter must be done here, and requires 
c recompiling the program

c common variables
c Biological properties
      real sel(0:maxage,2),rm(0:maxage),west(0:maxage),weca(0:maxage),
     &rmat(0:maxage),rnin(0:maxage),vcv(0:maxage,0:maxage)
      real truen(0:maxage,-maxage:maxyr),
     &projn(0:maxage,-maxage:maxyr),rninit(niter,0:maxage) 
      real pastssb(0:maxage),propm,propf
      integer iaref1,iaref2,lowage,iaold,iy0,idensflag,itsbage
c growth and maturity parameters
      real wecaspec(0:maxage,5),westspec(0:maxage,5),
     &voksenspec(0:maxage,5),wyclfct(-maxage:maxyrp),wyclfct0
      real wampl,wperiod,wphase,wsigma,wbref,wrref,
     &wycllow,wyclhigh,wyclalfa,wincrlow,wincrhigh,wincralfa
c recruitment      
      real recrparam(maxyr,niter,13),asrparam,bsrparam,
     &sigmar,rtrunc1,rtrunc2,asrorg,bsrorg,rinterval,rintvcv,spasmfct,
     &depens,ramplitude,rperiod,rphase,regintv,ar,xmprev
      integer irecrcode(maxyr,niter,5),jdist,jfunc,jtrunc,
     &ispasm(-maxage:maxyr)
      integer lastspasm,ioptspasm,nregimes,icodeshift,listreg(maxyr),
     &lastreg,nregact(-maxage:maxyrp)
c initialisation      
      real fprim,tac0
      integer idata,iflgab(maxyr)
c random seed
      double precision rintvar
c bounds
      real fmax,blim,sigmablim
      integer idistblim
c noise
      real cvnin(0:maxage),cvobs(0:maxage,2),cvimp(0:maxage),
     &biasobs,biasimp,yfctnin,yfctobs,yfctimp
      integer nac
c obs model info
      real xsiobs(0:maxage,-maxage:maxyr),
     &cobs(0:maxage,-maxage:maxyr+mbasis),
     &obsn(0:maxage,-maxage:maxyr+mbasis,-maxage:maxyr+mbasis),
     &fobs(-maxage:maxyr+mbasis),
     &acfact(0:maxage),
     &recrsurv(-maxage:maxyr+mbasis),
     &biosurv(-maxage:maxyr+mbasis,2)
      integer iobsstart,iobsend,ibastable(mbasis,4),icbastable(2,4)
c options for recruitment in decision process
      integer iydrec1,iydrec2,iydrec3,ioptdr1,ioptdr2
      real sigmadr,recmean      
c management option indicators
      integer idur,iproj,ibasrule,lastassn,ialwonly,
     &iabrgrad,iya1,iya2,ibplusage,nbasis,irule,iyback,nrecryears
      real optrange(nopt,3),hcrparam(nopt),bbfactor
c collect results
      real truessb(0:maxyr,1:niter),
     &trueweca(-maxage:maxyr,0:maxage),
     &truewest(-maxage:maxyr,0:maxage),
     &truemat(-maxage:maxyr,0:maxage),
     &truecatch(0:maxyr,1:niter),
     &tac(0:maxyr,1:niter),
     &truef(0:maxyr,1:niter),
     &obsf(0:maxyr,niter),

     &truetsb(0:maxyr,1:niter),
     &obsssb(0:maxyr,1:niter),
     &obsrecr(0:maxyr,1:niter),
     &truerecr(0:maxyr,1:niter),
     &rn7(0:maxyr,1:niter),
     &truebas(mbasis,0:maxyr),
     &decbas(0:maxyr,mbasis,niter)
      integer iflag(0:maxyr,1:niter),iter,ioutopt(11:27),nruleparam
c file names
      character*30 innfilb,innfilo,densfil,innfilc
      character*500 headline(2)
      character*45 fmtline1
      character*71 fmtline2

c Printout year intervals file 12
      integer intvpr1,intvpr2

      common rintvar,truessb,truecatch,truef,obsssb,decbas,
     &vcv,sel,rm,west,weca,rmat,rnin,pastssb,bbfactor,
     &xsiobs,cobs,fobs,recrsurv,biosurv,rninit,
     &propm,propf,asrparam,bsrparam,sigmar,rtrunc1,rtrunc2,
     &recrparam,asrorg,bsrorg,rinterval,rintvcv,spasmfct,
     &depens,ramplitude,rperiod,rphase,fprim,tac0,fmax,blim,sigmablim,
     &wecaspec,westspec,voksenspec,wycllow,wyclhigh,
     &wyclalfa,wincrlow,wincrhigh,wincralfa,
     &wampl,wperiod,wphase,wsigma,wbref,wrref,wyclfct0,wyclfct,
     &regintv,ar,xmprev,sigmadr,recmean,truen,obsn,projn ,obsf,tac,
     &iflag,irecrcode,ispasm,ioutopt,jdist,jfunc,jtrunc,lastspasm,iter,
     &iaref1,iaref2,lowage,iaold,iy0,idata,ibplusage,iyback,nrecryears,
     &idur,iproj,ibasrule,lastassn,ialwonly,icbastable,idistblim,
     &iobsstart,iobsend,ibastable,irule,nac,
     &iabrgrad,iya1,iya2,nbasis,idensflag,itsbage,nruleparam,
     &ioptspasm,listreg,lastreg,nregimes,icodeshift,nregact,
     &intvpr1,intvpr2,iflgab,iydrec1,iydrec2,iydrec3,ioptdr1,ioptdr2,
     &truerecr, optrange,xmold,cvnin,cvobs,cvimp,hcrparam,
     &biasobs,biasimp,yfctnin,yfctobs,yfctimp,acfact,truetsb,obsrecr,
     &truewest,trueweca,truemat,rn7,truebas,innfilb,innfilo,densfil,
     &innfilc,headline,fmtline1,fmtline2
  

   
